/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.service.CiudadService;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.service.PlazaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Row;

/**
 *
 * @author MCosso
 */
@Controller("editarCiudadController")
@Scope("prototype")
public class EditarCiudadController extends MyGenericForwardComposer {

    @Autowired
    private CiudadService ciudadService;
    @Autowired
    private EstadoService estadoService;
    @Autowired
    private PlazaService plazaService;
    private List<Estado> lsEstado;
    private List<Plaza> lsPlaza;
    private Ciudad ciudad;
    private MyListbox ciudadList;
    private static Logger log = Logger.getLogger(EditarCiudadController.class);
    private MyTextbox txtNome;
    private Combobox cmbEstado;
    private Combobox cmbPlaza;
    private Button btnApagar;
    private Row rowEquivalencia;

    public Ciudad getCiudad() {
        return ciudad;
    }

    public void setCiudad(Ciudad ciudad) {
        this.ciudad = ciudad;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public MyListbox getCiudadList() {
        return ciudadList;
    }

    public void setCiudadList(MyListbox ciudadList) {
        this.ciudadList = ciudadList;
    }

    public List<Estado> getLsEstado() {
        return lsEstado;
    }

    public void setLsEstado(List<Estado> lsEstado) {
        this.lsEstado = lsEstado;
    }

    public List<Plaza> getLsPlaza() {
        return lsPlaza;
    }

    public void setLsPlaza(List<Plaza> lsPlaza) {
        this.lsPlaza = lsPlaza;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public Combobox getCmbEstado() {
        return cmbEstado;
    }

    public void setCmbEstado(Combobox cmbEstado) {
        this.cmbEstado = cmbEstado;
    }

    public Combobox getCmbPlaza() {
        return cmbPlaza;
    }

    public void setCmbPlaza(Combobox cmbPlaza) {
        this.cmbPlaza = cmbPlaza;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsEstado = estadoService.obtenerTodos();
        lsPlaza = plazaService.obtenerTodos();

        super.doAfterCompose(comp);

        ciudad = (Ciudad) Executions.getCurrent().getArg().get("ciudad");
        ciudadList = (MyListbox) Executions.getCurrent().getArg().get("ciudadList");

        if (ciudad.getCiudadId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        cmbEstado.getValue();
        cmbEstado.getValue();

        try {
            ciudad.setActivo(Boolean.TRUE);
            ciudad.setFecmodif(Calendar.getInstance().getTime());
            ciudad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Ciudad> lsCiudad = ciudadService.buscar(ciudad.getNombciudad(),
                    ciudad.getEstado(), ciudad.getPlaza());

            boolean podeSalvar = false;
            if (lsCiudad.isEmpty()) {
                podeSalvar = true;
            } else {
                if (ciudad.getCiudadId() != null) {
                    for (Ciudad c : lsCiudad) {
                        if (c.getCiudadId().equals(ciudad.getCiudadId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }
            if (podeSalvar) {
                if (ciudad.getCiudadId() == null) {
                    ciudadService.suscribir(ciudad);
                    ciudadList.addItem(ciudad);
                } else {
                    ciudadService.actualizacion(ciudad);
                    ciudadList.updateItem(ciudad);
                }

                Messagebox.show(
                        Labels.getLabel("editarCiudadController.MSG.suscribirOK"),
                        Labels.getLabel("editarCiudadController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarCiudadController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error("editarCiudadController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarCiudadController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarCiudadController.MSG.borrarPergunta"),
                    Labels.getLabel("editarCiudadController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                ciudadService.borrar(ciudad);

                Messagebox.show(
                        Labels.getLabel("editarCiudadController.MSG.borrarOK"),
                        Labels.getLabel("editarCiudadController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                ciudadList.removeItem(ciudad);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
