/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.ConfigRestriccionPago;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderRestriccionFormaPago;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaRestriccionFormaPagoController")
@Scope("prototype")
public class BusquedaRestriccionFormaPagoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ConfigRestriccionPago> plwRestriccionFormaPago;
    private MyListbox restriccionFormaPagoList;
    private Paging pagingrestriccionFormaPago;
    private Textbox txtNome;

    public Paging getPagingrestriccionFormaPago() {
        return pagingrestriccionFormaPago;
    }

    public void setPagingrestriccionFormaPago(Paging pagingrestriccionFormaPago) {
        this.pagingrestriccionFormaPago = pagingrestriccionFormaPago;
    }

    public MyListbox getRestriccionFormaPagoList() {
        return restriccionFormaPagoList;
    }

    public void setRestriccionFormaPagoList(MyListbox restriccionFormaPagoList) {
        this.restriccionFormaPagoList = restriccionFormaPagoList;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        restriccionFormaPagoList.setItemRenderer(new RenderRestriccionFormaPago());
        restriccionFormaPagoList.addEventListener("onDoubleClick",
                new EventListener() {

                    @Override
                    public void onEvent(Event event) throws Exception {
                        ConfigRestriccionPago c =
                                (ConfigRestriccionPago) restriccionFormaPagoList.getSelected();
                        verConfigRestriccionPago(c);
                    }
                });

        refreshLista();

        txtNome.focus();
    }

    private void verConfigRestriccionPago(ConfigRestriccionPago c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("configRestriccionPago", c);
        args.put("configRestriccionFormaPagoList", restriccionFormaPagoList);

        openWindow("/gui/configuraciones_comerciales/editarRestriccionFormaPago.zul",
                Labels.getLabel("editarRestriccionFormaPagoController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ConfigRestriccionPago> configRestriccionPagoBusqueda =
                new HibernateSearchObject<ConfigRestriccionPago>(
                ConfigRestriccionPago.class,
                pagingrestriccionFormaPago.getPageSize());

        configRestriccionPagoBusqueda.addFilterLike("formaPago.descpago",
                "%" + txtNome.getText().trim().concat("%"));

        configRestriccionPagoBusqueda.addSortAsc("formaPago.descpago");
        configRestriccionPagoBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwRestriccionFormaPago.init(configRestriccionPagoBusqueda,
                restriccionFormaPagoList, pagingrestriccionFormaPago);

        if (restriccionFormaPagoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaRestriccionFormaPagoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verConfigRestriccionPago(new ConfigRestriccionPago());
    }
}
