/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Combobox;

import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.ProdMarca;
import com.rjconsultores.ventaboletos.entidad.ProdPrecio;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.ProdMarcaService;
import com.rjconsultores.ventaboletos.service.ProdPrecioService;
import com.rjconsultores.ventaboletos.utilerias.TraslaparUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCyberViajeProdPrecio;

/**
 *
 * @author Administrador
 */
@Controller("editarProdMarcaController")
@Scope("prototype")
public class EditarProdMarcaController extends MyGenericForwardComposer {

    @Autowired
    private ProdMarcaService prodMarcaService;
    @Autowired
    private MarcaService marcaService;
    @Autowired
    private ProdPrecioService prodPrecioService;
    private List<Marca> lsMarca;
    private MyListbox prodMarcaList;
    private ProdMarca prodMarca;
    private Combobox cmbProdMarca;
    private List<ProdMarca> lsProdMarca;
    private MyListbox prodPrecioList;
    private List<ProdPrecio> lsProdPrecio;
    private MyTextboxDecimal txtImporteInicial;
    private MyTextboxDecimal txtImporteFinal;
    private MyTextboxDecimal tarifa;
    private static Logger log = Logger.getLogger(EditarProdMarcaController.class);

    public List<Marca> getLsMarca() {
        return lsMarca;
    }

    public void setLsMarca(List<Marca> lsMarca) {
        this.lsMarca = lsMarca;
    }

    public ProdMarca getProdMarca() {
        return prodMarca;
    }

    public void setProdMarca(ProdMarca prodMarca) {
        this.prodMarca = prodMarca;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsProdPrecio = new ArrayList<ProdPrecio>();
        lsMarca = marcaService.obtenerTodos();
        lsProdMarca = (List<ProdMarca>) Executions.getCurrent().getArg().get("lsProdMarca");
        prodMarca = (ProdMarca) Executions.getCurrent().getArg().get("prodMarca");
        prodMarcaList = (MyListbox) Executions.getCurrent().getArg().get("prodMarcaList");

        if (prodMarca.getProdmarcaId() != null) {
            lsProdPrecio = prodPrecioService.buscar(prodMarca.getMarca(), prodMarca.getProductoServicio());
        }
        super.doAfterCompose(comp);

        prodPrecioList.setItemRenderer(new RenderCyberViajeProdPrecio());
        prodPrecioList.setData(lsProdPrecio);
        habilitarCombo();
    }

    private void habilitarCombo() {
        cmbProdMarca.setDisabled(!lsProdPrecio.isEmpty());
    }

    public void onClick$btnApagarProdPrecio(Event ev) throws Exception {
        if (prodPrecioList.getSelected() == null) {
            Clients.alert(Labels.getLabel("editarProdMarcaController.MSG.seleccionarUnImporte"), Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"), Messagebox.INFORMATION);
            return;
        }
        ProdPrecio selected = (ProdPrecio) prodPrecioList.getSelected();
        prodPrecioService.borrar(selected);
        lsProdPrecio.remove(selected);
        prodPrecioList.setData(lsProdPrecio);
        habilitarCombo();

    }

    public void onClick$btnNovoProdPrecio(Event ev) throws Exception {

        txtImporteInicial.setConstraint("no empty");
        txtImporteFinal.setConstraint("no empty");
        tarifa.setConstraint("no empty");

        cmbProdMarca.getValue();
        txtImporteInicial.getValue();
        txtImporteFinal.getValue();
        tarifa.getValue();


        if ((txtImporteInicial.getValueDecimal() == null) || (txtImporteFinal.getValueDecimal() == null)) {
            Clients.alert(Labels.getLabel("editarProdMarcaController.MSG.valoresImportes"),
                    Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                    Messagebox.INFORMATION);
            return;
        }

        Collections.sort(lsProdPrecio, new Comparator<ProdPrecio>() {

            public int compare(ProdPrecio o1, ProdPrecio o2) {
                return o1.getImporteinicial().compareTo(o2.getImporteinicial());
            }
        });


        boolean traslapa = false;
        for (ProdPrecio pp : lsProdPrecio) {
            if (TraslaparUtil.intersectNum(pp.getImporteinicial(), pp.getImportefinal(), txtImporteInicial.getValueDecimal(), txtImporteFinal.getValueDecimal())) {
                traslapa = true;
            }
        }

        if (traslapa) {
            Clients.alert(Labels.getLabel("editarProdMarcaController.MSG.conflitoVigencias"),
                    Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                    Messagebox.INFORMATION);
            return;
        }


        ProdPrecio prodPrecio = new ProdPrecio();
        prodPrecio.setMarca(prodMarca.getMarca());
        prodPrecio.setProductoservicio(prodMarca.getProductoServicio());
        prodPrecio.setImportefinal(txtImporteFinal.getValueDecimal());
        prodPrecio.setImporteinicial(txtImporteInicial.getValueDecimal());
        prodPrecio.setPrecio(tarifa.getValueDecimal());
        lsProdPrecio.add(prodPrecio);
        prodPrecioList.setData(lsProdPrecio);

        txtImporteInicial.setConstraint("");
        txtImporteFinal.setConstraint("");
        tarifa.setConstraint("");

        txtImporteInicial.setValue(null);
        txtImporteFinal.setValue(null);
        tarifa.setValue(null);

        habilitarCombo();
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {
        cmbProdMarca.getValue();
        try {

            if (prodMarca.getMarca() == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Error.combobox"),
                        Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }

            if (prodPrecioList.getData().length == 0) {
                Messagebox.show(
                        Labels.getLabel("editarProdMarcaController.MSG.necesitaImporte"),
                        Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }

            if (prodMarca.getProdmarcaId() != null) {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);

                    return;
                }
                prodMarcaService.actualizacion(prodMarca, lsProdPrecio);
                prodMarcaList.updateItem(prodMarca);
                lsProdMarca.add(prodMarca);
            } else {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);

                    return;
                }
                prodMarcaService.suscribir(prodMarca, lsProdPrecio);
                prodMarcaList.addItem(prodMarca);
                lsProdMarca.add(prodMarca);
            }
            Messagebox.show(
                    Labels.getLabel("editarProdMarcaController.MSG.salvarOk"),
                    Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    private boolean registroDuplicado() throws InterruptedException {
        for (ProdMarca p : lsProdMarca) {
            if (!p.getActivo()) {
                continue;
            }
            Boolean igualID = Boolean.FALSE;
            if (prodMarca.getProdmarcaId() != null) {
                igualID = prodMarca.getProdmarcaId().equals(p.getProdmarcaId());
            }

            if ((p.getMarca().getDescmarca().equals(prodMarca.getMarca().getDescmarca()))
                    && (!igualID)) {

                return true;
            }
        }

        return false;
    }

    public void onClick$btnRemover(Event ev) throws InterruptedException {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdMarcaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodMarca.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodMarca.setFecmodif(Calendar.getInstance().getTime());
                prodMarca.setActivo(Boolean.FALSE);

                prodMarcaList.removeItem(prodMarca);
                prodMarcaService.borrar(prodMarca);

                Messagebox.show(
                        Labels.getLabel("editarProdMarcaController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarProdMarcaController.winEditarProdMarca.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    /**
     * @return the lsProdMarca
     */
    public List<ProdMarca> getLsProdMarca() {
        return lsProdMarca;
    }

    /**
     * @param lsProdMarca the lsProdMarca to set
     */
    public void setLsProdMarca(List<ProdMarca> lsProdMarca) {
        this.lsProdMarca = lsProdMarca;
    }
}
