/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.recaudacion;

import com.rjconsultores.ventaboletos.entidad.Autobus;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.TarjetaRecaudacion;
import com.rjconsultores.ventaboletos.entidad.TarjetaRecaudacionPK;
import com.rjconsultores.ventaboletos.service.AutobusService;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TarjetaRecaudacionService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTarjetaRecaudacionController")
@Scope("prototype")
public class EditarTarjetaRecaudacionController extends MyGenericForwardComposer {

    @Autowired
    private TarjetaRecaudacionService tarjetaRecaudacionService;
    @Autowired
    private EmpresaService empresaService;
    @Autowired
    private RutaService rutaService;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private AutobusService autobusService;
    private List<Empresa> lsEmpresas;
    private List<Ruta> lsRutas;
    private List<ClaseServicio> lsClaseSsClervico;
    private List<Autobus> lsAutobus;
    private TarjetaRecaudacion tarjetaRecaudacion;
    private MyListbox tarjetaRecaudacionList;
    private Datebox databoxFecHor;
    private Intbox intboxCorrida;
    private Intbox numTarjeta;
    private Checkbox chkManual;
    private Checkbox chkActualizado;
    private Integer claveConductor;
    private Textbox clvConductor;

    public List<ClaseServicio> getLsClaseSsClervico() {
        return lsClaseSsClervico;
    }

    public void setLsClaseSsClervico(List<ClaseServicio> lsClaseSsClervico) {
        this.lsClaseSsClervico = lsClaseSsClervico;
    }

    public List<Empresa> getLsEmpresas() {
        return lsEmpresas;
    }

    public void setLsEmpresas(List<Empresa> lsEmpresas) {
        this.lsEmpresas = lsEmpresas;
    }

    public List<Ruta> getLsRutas() {
        return lsRutas;
    }

    public void setLsRutas(List<Ruta> lsRutas) {
        this.lsRutas = lsRutas;
    }

    public TarjetaRecaudacion getTarjetaRecaudacion() {
        return tarjetaRecaudacion;
    }

    public void setTarjetaRecaudacion(TarjetaRecaudacion tarjetaRecaudacion) {
        this.tarjetaRecaudacion = tarjetaRecaudacion;
    }

    public void atualizarCorridaTela(Date fecHor, Integer corridaId) {
        intboxCorrida.setValue(corridaId);
        databoxFecHor.setValue(fecHor);
    }

    public Checkbox getChkActualizado() {
        return chkActualizado;
    }

    public void setChkActualizado(Checkbox chkActualizado) {
        this.chkActualizado = chkActualizado;
    }

    public Checkbox getChkManual() {
        return chkManual;
    }

    public void setChkManual(Checkbox chkManual) {
        this.chkManual = chkManual;
    }

    public Datebox getDataboxFecHor() {
        return databoxFecHor;
    }

    public void setDataboxFecHor(Datebox databoxFecHor) {
        this.databoxFecHor = databoxFecHor;
    }

    public Intbox getIntboxCorrida() {
        return intboxCorrida;
    }

    public void setIntboxCorrida(Intbox intboxCorrida) {
        this.intboxCorrida = intboxCorrida;
    }

    public Intbox getNumTarjeta() {
        return numTarjeta;
    }

    public void setNumTarjeta(Intbox numTarjeta) {
        this.numTarjeta = numTarjeta;
    }

    public List<Autobus> getLsAutobus() {
        return lsAutobus;
    }

    public void setLsAutobus(List<Autobus> lsAutobus) {
        this.lsAutobus = lsAutobus;
    }

    public Textbox getClvConductor() {
        return clvConductor;
    }

    public void setClvConductor(Textbox clvConductor) {
        this.clvConductor = clvConductor;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsEmpresas = empresaService.buscarTodosExceto(-1);
        lsRutas = rutaService.buscarTodosExceto(-1);
        lsClaseSsClervico = claseServicioService.buscarTodosExceto(-1);
        lsAutobus = autobusService.obtenerTodos();

        super.doAfterCompose(comp);

        claveConductor = (Integer) Executions.getCurrent().getArg().get("claveConductor");
        if (claveConductor != null) {
            clvConductor.setValue(claveConductor.toString());
        }

        tarjetaRecaudacion = (TarjetaRecaudacion) Executions.getCurrent().getArg().get("tarjetaRecaudacion");
        if (tarjetaRecaudacion.getTarjetasRecaudacionPK() != null) {
            tarjetaRecaudacion = tarjetaRecaudacionService.obtenerID(tarjetaRecaudacion.getTarjetasRecaudacionPK());
        }
        tarjetaRecaudacionList = (MyListbox) Executions.getCurrent().getArg().get("tarjetaRecaudacionList");
    }

    public void onClick$btnPesquisarCorrida(Event ev) {
        Map args = new HashMap();
        args.put("tarjetaRecaudacion", tarjetaRecaudacion);
        args.put("editarTarjetaRecaudacionController", this);

        openWindow("/gui/recaudacion/busquedaCorridaTarjetaRecaudacion.zul",
                Labels.getLabel("editarPricingController.windowCorrida.title"), args, MODAL);
    }

    public void onClick$btnSalvar(Event ev) {
        if (tarjetaRecaudacion.getTarjetasRecaudacionPK() == null) {
            tarjetaRecaudacion.setConductorId(claveConductor);
            tarjetaRecaudacion.setActivo(Boolean.TRUE);
            tarjetaRecaudacion.setActualizar(Boolean.FALSE);

            TarjetaRecaudacionPK tarjetasRecaudacionPK = new TarjetaRecaudacionPK();
            tarjetasRecaudacionPK.setManual(chkManual.isChecked());
            tarjetasRecaudacionPK.setTarjetarecaudacionId(numTarjeta.getValue());

            tarjetaRecaudacion.setTarjetasRecaudacionPK(tarjetasRecaudacionPK);
            tarjetaRecaudacionService.suscribir(tarjetaRecaudacion);

            tarjetaRecaudacionList.addItem(tarjetaRecaudacion);
        } else {
            tarjetaRecaudacionService.actualizacion(tarjetaRecaudacion);
            tarjetaRecaudacion.setActualizar(Boolean.TRUE);

            tarjetaRecaudacionList.updateItem(tarjetaRecaudacion);
        }

        closeWindow();
    }
}
